pro XMAP_test

n_xpixels=256
n_ypixels=2048
x_pixel_size=0.010
y_pixel_size=0.010
pixel_time=0.01
;collection mode, 0=mca spectra, 1=mca mapping, 2=sca mapping
collect_mode=1
filename='junk'
filenumber=1
est_time=n_ypixels*(pixel_time*n_xpixels+1.0)
print,'estimated time (secs) = ',est_time

s=caget('dxpXMAP:PixelsPerBuffer_RBV',pixels_per_buffer)

;x=obj_new('EPICS_MOTOR','13LAB:m31')
;y=obj_new('EPICS_MOTOR','13LAB:m2')
;x_start=x->get_position()
;y_start=y->get_position()


;s=caget('13LAB:m31.MRES',motor_res)
;s=caput('13LAB:str:Prescale',fix(abs(x_pixel_size/motor_res)+0.5))
s=caput('13LAB:str:Dwell', pixel_time)

s=caput('dxpXMAP:CollectMode',collect_mode)
s=caput('dxpXMAP:PixelAdvanceMode',"Gate")
s=caput('dxpXMAP:PixelsPerRun',n_xpixels)
s=caput('13LAB:str:NuseAll',n_xpixels)
;set netcdf #  capture
n=((n_xpixels-1)/pixels_per_buffer)+1
s=caput('dxpXMAP:netCDF1:NumCapture',n)

s=caput('dxpXMAP:netCDF1:FileName',[byte(filename),0B])
s=caput('dxpXMAP:netCDF1:FileNumber',filenumber)
wait,5.0

;s=caGet('13LAB:Keithley_486_current.VAL',i0)

for i=0,n_ypixels-1 do begin
	print,'collecting row ',i,systime()
	;s=caGet('13LAB:Keithley_486_current.VAL',i0_new)
	;print,'Ion chamber decay: ',i0_new/i0
	;s=caput('13LAB:m31.VELO',x_pixel_size/pixel_time)
	s=caput('dxpXMAP:netCDF1:Capture',1)
	s=caput('dxpXMAP:EraseStart',1)
	print,'Waiting 1 sec to start'
	wait,0.25
	s=caput('13LAB:str:EraseStart',1)
	;x->move,(n_xpixels+1)*x_pixel_size,/relative
	netbusy=1
	while netbusy eq 1 do begin
		s=caget('dxpXMAP:netCDF1:WriteFile_RBV',netbusy)
		wait,0.01
		;TESTING
		s=caget('dxpXMAP:dxp1:CurrentPixel',current_pixel)
		print,'current pixel is: ',current_pixel
	endwhile
	;x->wait
	;s=caput('13LAB:m31.VELO',1.00)
	;x->move,-(n_xpixels+1)*x_pixel_size,/relative
	;x->move,x_start
	;y->move,y_pixel_size,/relative
	;x->wait
	;y->wait

endfor

;x->move,x_start
;y->move,y_start

end